Index: /bdm/stat/libBM.h
===================================================================
--- /bdm/stat/libBM.h (revision 267)
+++ /bdm/stat/libBM.h (revision 270)
@@ -14,4 +14,6 @@
 \defgroup core Core BDM classes
 @{
+\defgroup const Constructors
+\defgroup math Mathematical operations
 */
 #ifndef BM_H
@@ -20,203 +22,261 @@
 
 #include "../itpp_ext.h"
-//#include <std>
+#include <map>
 
 namespace bdm {
-	using namespace itpp;
-	using std::string;
+using namespace itpp;
+using namespace std;
 
 //! Root class of BDM objects
-	class bdmroot {
-		virtual void print() {}
+class bdmroot {
+public:
+	//! make sure this is a virtual object
+	virtual ~bdmroot() {}
+};
+
+typedef std::map<string, int> RVmap;
+extern ivec RV_SIZES;
+extern Array<string> RV_NAMES;
+
+//! Structure of RV (used internally), i.e. expanded RVs
+class str {
+public:
+	//! vector id ids (non-unique!)
+	ivec ids;
+	//! vector of times
+	ivec times;
+	//!Default constructor
+	str ( ivec ids0, ivec times0 ) :ids ( ids0 ),times ( times0 ) {
+		it_assert_debug ( times0.length() ==ids0.length(),"Incompatible input" );
 	};
-
-//! Structure of RV (used internally), i.e. expanded RVs
-	class str {
-	public:
-		//! vector id ids (non-unique!)
-		ivec ids;
-		//! vector of times
-		ivec times;
-		//!Default constructor
-		str ( ivec ids0, ivec times0 ) :ids ( ids0 ),times ( times0 ) {
-			it_assert_debug ( times0.length() ==ids0.length(),"Incompatible input" );
-		};
+};
+
+/*!
+* \brief Class representing variables, most often random variables
+
+The purpose of this class is to decribe a vector of data. Such description is used for connecting various vectors between each other, see class datalink.
+
+The class is implemented using global variables to assure uniqueness of description:
+
+ In is a vector
+\dot
+digraph datalink {
+rankdir=LR;
+subgraph cluster0 {
+node [shape=record];
+label = "RV_MAP \n std::map<string,int>";
+map [label="{{\"a\"| \"b\" | \"c\"} | {<3> 3 |<1> 1|<2> 2}}"];
+color = "white"
+}
+subgraph cluster1{
+node [shape=record];
+label = "RV_NAMES";
+names [label="{<1> \"b\" | <2> \"c\" | <3>\"a\" }"];
+color = "white"
+}
+subgraph cluster2{
+node [shape=record];
+label = "RV_SIZES";
+labelloc = b;
+sizes [label="{<1>1 |<2> 4 |<3> 1}"];
+color = "white"
+}
+map:1 -> names:1;
+map:1 -> sizes:1;
+map:3 -> names:3;
+map:3 -> sizes:3;
+}
+\enddot
+*/
+
+class RV :public bdmroot {
+protected:
+	//! size of the data vector
+	int dsize;
+	//! number of individual rvs
+	int len;
+	//! Vector of unique IDs
+	ivec ids;
+	//! Vector of shifts from current time
+	ivec times;
+
+private:
+	//! auxiliary function used in constructor
+	void init ( Array<std::string> in_names, ivec in_sizes, ivec in_times );
+	int init ( const  string &name, int size );
+public:
+	//! \name Constructors 
+	//!@{
+	
+	//! Full constructor 
+	RV ( Array<std::string> in_names, ivec in_sizes, ivec in_times ) {init ( in_names,in_sizes,in_times );};
+	//! Constructor with times=0 
+	RV ( Array<std::string> in_names, ivec in_sizes ) {init ( in_names,in_sizes,zeros_i ( in_names.length() ) );};
+	//! Constructor with sizes=1, times=0 
+	RV ( Array<std::string> in_names ) {init ( in_names,ones_i ( in_names.length() ),zeros_i ( in_names.length() ) );}
+	//! Constructor of empty RV 
+	RV () :dsize ( 0 ),len ( 0 ),ids ( 0 ),times ( 0 ) {};
+	//! Constructor of a single RV with given id
+	RV ( string name, int sz, int tm=0 );
+	//!@}
+	
+	//! \name Access functions
+	//!@{
+	
+	//! Printing output e.g. for debugging.
+	friend std::ostream &operator<< ( std::ostream &os, const RV &rv );
+	int _dsize() const {return dsize;} ;
+	//! Recount size of the corresponding data vector
+	int countsize() const;
+	int length() const {return len;} ;
+	int id ( int at ) const{return ids ( at );};
+	int size ( int at ) const {return RV_SIZES ( at );};
+	int time ( int at ) const{return times ( at );};
+	std::string name ( int at ) const {return RV_NAMES ( at );};
+	void set_time ( int at, int time0 ) {times ( at ) =time0;};
+	//!@}
+	
+	//TODO why not inline and later??
+
+	//! \name Algebra on Random Variables
+	//!@{
+	
+	//! Find indices of self in another rv, \return ivec of the same size as self.
+	ivec findself ( const RV &rv2 ) const;
+	//! Compare if \c rv2 is identical to this \c RV
+	bool equal ( const RV &rv2 ) const;
+	//! Add (concat) another variable to the current one, \return true if all rv2 were added, false if rv2 is in conflict
+	bool add ( const RV &rv2 );
+	//! Subtract  another variable from the current one
+	RV subt ( const RV &rv2 ) const;
+	//! Select only variables at indeces ind
+	RV subselect ( const ivec &ind ) const;
+	//! Select only variables at indeces ind
+	RV operator() ( const ivec &ind ) const {return subselect ( ind );};
+	//! Shift \c time shifted by delta.
+	void t ( int delta );
+	//!@}
+	
+	//!\name Relation to vectors 
+	//!@{
+	
+	//! generate \c str from rv, by expanding sizes
+	str tostr() const;
+	//! when this rv is a part of bigger rv, this function returns indeces of self in the data vector of the bigger crv.
+	//! Then, data can be copied via: data_of_this = cdata(ind);
+	ivec dataind ( const RV &crv ) const;
+	//! generate mutual indeces when copying data betwenn self and crv.
+	//! Data are copied via: data_of_this(selfi) = data_of_rv2(rv2i)
+	void dataind ( const RV &rv2, ivec &selfi, ivec &rv2i ) const;
+	//! Minimum time-offset
+	int mint () const {return min ( times );};
+	//!@}
+	
+};
+
+
+//! Concat two random variables
+RV concat ( const RV &rv1, const RV &rv2 );
+
+//!Default empty RV that can be used as default argument
+extern RV RV0;
+
+//! Class representing function \f$f(x)\f$ of variable \f$x\f$ represented by \c rv
+
+class fnc :public bdmroot {
+protected:
+	//! Length of the output vector
+	int dimy;
+public:
+	//!default constructor
+	fnc ( ) {};
+	//! function evaluates numerical value of \f$f(x)\f$ at \f$x=\f$ \c cond
+	virtual vec eval ( const vec &cond ) {
+		return vec ( 0 );
 	};
 
-	/*!
-	* \brief Class representing variables, most often random variables
-
-	* More?...
-	*/
-
-	class RV :public bdmroot {
-	protected:
-		//! size = sum of sizes
-		int tsize;
-		//! len = number of individual rvs
-		int len;
-		//! Vector of unique IDs
-		ivec ids;
-		//! Vector of sizes
-		ivec sizes;
-		//! Vector of shifts from current time
-		ivec times;
-		//! Array of names
-		Array<std::string> names;
-
-	private:
-		//! auxiliary function used in constructor
-		void init ( ivec in_ids, Array<std::string> in_names, ivec in_sizes, ivec in_times );
-	public:
-		//! Full constructor
-		RV ( Array<std::string> in_names, ivec in_sizes, ivec in_times );
-		//! Constructor with times=0
-		RV ( Array<std::string> in_names, ivec in_sizes );
-		//! Constructor with sizes=1, times=0
-		RV ( Array<std::string> in_names );
-		//! Constructor of empty RV
-		RV ();
-		//! Constructor of a single RV with given id
-		RV (string name, int id, int sz=1, int tm=0);
-
-		//! Printing output e.g. for debugging.
-		friend std::ostream &operator<< ( std::ostream &os, const RV &rv );
-
-		//! Return number of scalars in the RV.
-		int count() const {return tsize;} ;
-		//! Return length (number of entries) of the RV.
-		int length() const {return len;} ;
-
-		//TODO why not inline and later??
-
-		//! Find indexes of self in another rv, \return ivec of the same size as self.
-		ivec findself ( const RV &rv2 ) const;
-		//! Compare if \c rv2 is identical to this \c RV
-		bool equal ( const RV &rv2 ) const;
-		//! Add (concat) another variable to the current one, \return true if all rv2 were added, false if rv2 is in conflict
-		bool add ( const RV &rv2 );
-		//! Subtract  another variable from the current one
-		RV subt ( const RV &rv2 ) const;
-		//! Select only variables at indeces ind
-		RV subselect ( const ivec &ind ) const;
-		//! Select only variables at indeces ind
-		RV operator() ( const ivec &ind ) const;
-		//! Shift \c time shifted by delta.
-		void t ( int delta );
-		//! generate \c str from rv, by expanding sizes
-		str tostr() const;
-		//! when this rv is a part of bigger rv, this function returns indeces of self in the data vector of the bigger crv.
-		//! Then, data can be copied via: data_of_this = cdata(ind);
-		ivec dataind ( const RV &crv ) const;
-		//! generate mutual indeces when copying data betwenn self and crv.
-		//! Data are copied via: data_of_this(selfi) = data_of_rv2(rv2i)
-		void dataind ( const RV &rv2, ivec &selfi, ivec &rv2i ) const;
-		//! Minimum time-offset
-		int mint () const {return min ( times );};
-
-		//!access function
-		Array<std::string>& _names() {return names;};
-
-		//!access function
-		int id ( int at ) {return ids ( at );};
-		//!access function
-		int size ( int at ) {return sizes ( at );};
-		//!access function
-		int time ( int at ) {return times ( at );};
-		//!access function
-		std::string name ( int at ) {return names ( at );};
-
-		//!access function
-		void set_id ( int at, int id0 ) {ids ( at ) =id0;};
-		//!access function
-		void set_size ( int at, int size0 ) {sizes ( at ) =size0; tsize=sum ( sizes );};
-		//!access function
-		void set_time ( int at, int time0 ) {times ( at ) =time0;};
-
-		//!Assign unused ids to this rv
-		void newids();
-	};
-
-//! Concat two random variables
-	RV concat ( const RV &rv1, const RV &rv2 );
-
-//!Default empty RV that can be used as default argument
-	extern RV RV0;
-
-//! Class representing function \f$f(x)\f$ of variable \f$x\f$ represented by \c rv
-
-	class fnc :public bdmroot {
-	protected:
-		//! Length of the output vector
-		int dimy;
-	public:
-		//!default constructor
-		fnc ( int dy ) :dimy ( dy ) {};
-		//! function evaluates numerical value of \f$f(x)\f$ at \f$x=\f$ \c cond
-		virtual vec eval ( const vec &cond ) {
-			return vec ( 0 );
-		};
-
-		//! function substitutes given value into an appropriate position
-		virtual void condition ( const vec &val ) {};
-
-		//! access function
-		int _dimy() const{return dimy;}
-
-		//! Destructor for future use;
-		virtual ~fnc() {};
-	};
-
-	class mpdf;
+	//! function substitutes given value into an appropriate position
+	virtual void condition ( const vec &val ) {};
+
+	//! access function
+	int _dimy() const{return dimy;}
+};
+
+class mpdf;
 
 //! Probability density function with numerical statistics, e.g. posterior density.
 
-	class epdf :public bdmroot {
-	protected:
-		//! Identified of the random variable
-		RV rv;
-	public:
-		//!default constructor
-		epdf() :rv ( ) {};
-
-		//!default constructor
-		epdf ( const RV &rv0 ) :rv ( rv0 ) {};
-
-//	//! Returns the required moment of the epdf
-//	virtual vec moment ( const int order = 1 );
-
-		//! Returns a sample, \f$x\f$ from density \f$epdf(rv)\f$
-		virtual vec sample () const =0;
-		//! Returns N samples from density \f$epdf(rv)\f$
-		virtual mat sample_m ( int N ) const;
-
-		//! Compute log-probability of argument \c val
-		virtual double evallog ( const vec &val ) const =0;
-
-		//! Compute log-probability of multiple values argument \c val
-		virtual vec evallog_m ( const mat &Val ) const {
-			vec x ( Val.cols() );
-			for ( int i=0;i<Val.cols();i++ ) {x ( i ) =evallog ( Val.get_col ( i ) ) ;}
-			return x;
-		}
-		//! Return conditional density on the given RV, the remaining rvs will be in conditioning
-		virtual mpdf* condition ( const RV &rv ) const  {it_warning ( "Not implemented" ); return NULL;}
-		//! Return marginal density on the given RV, the remainig rvs are intergrated out
-		virtual epdf* marginal ( const RV &rv ) const {it_warning ( "Not implemented" ); return NULL;}
-
-		//! return expected value
-		virtual vec mean() const =0;
-
-		//! return expected variance (not covariance!)
-		virtual vec variance() const = 0;
-
-		//! Destructor for future use;
-		virtual ~epdf() {};
-		//! access function, possibly dangerous!
-		const RV& _rv() const {return rv;}
-		//! modifier function - useful when copying epdfs
-		void _renewrv ( const RV &in_rv ) {rv=in_rv;}
-		//!
-	};
+class epdf :public bdmroot {
+protected:
+	//! dimension of the random variable
+	int dim;
+	//! Description of the random variable
+	RV rv;
+
+public:
+	/*! \name Constructors
+	 Construction of each epdf should support two types of constructors: 
+	\li empty constructor, 
+	\li copy constructor,
+	
+	The following constructors should be supported for convenience:
+	\li constructor followed by calling \c set_parameters() 
+	\li constructor accepting random variables calling \c set_rv()
+	
+	 All internal data structures are constructed as empty. Their values (including sizes) will be set by method \c set_parameters(). This way references can be initialized in constructors.
+	@{*/
+	epdf() :dim(0),rv ( ) {};
+	epdf(const epdf &e) :dim(e.dim),rv (e.rv) {};
+	epdf(const RV &rv0) {set_rv(rv0);};
+	void set_parameters(int dim0){dim=dim0;}
+	//!@}
+	
+	//! \name Matematical Operations
+	//!@{
+	
+	//! Returns a sample, \f$ x \f$ from density \f$ f_x()\f$
+	virtual vec sample () const {it_error("not implemneted");return vec(0);};
+	//! Returns N samples, \f$ [x_1 , x_2 , \ldots \ \f$  from density \f$ f_x(rv)\f$
+	virtual mat sample_m ( int N ) const;
+	//! Compute log-probability of argument \c val
+	virtual double evallog ( const vec &val ) const {it_error("not implemneted");return 0.0;};
+	//! Compute log-probability of multiple values argument \c val
+	virtual vec evallog_m ( const mat &Val ) const {
+		vec x ( Val.cols() );
+		for ( int i=0;i<Val.cols();i++ ) {x ( i ) =evallog ( Val.get_col ( i ) ) ;}
+		return x;
+	}
+	//! Return conditional density on the given RV, the remaining rvs will be in conditioning
+	virtual mpdf* condition ( const RV &rv ) const  {it_warning ( "Not implemented" ); return NULL;}
+	//! Return marginal density on the given RV, the remainig rvs are intergrated out
+	virtual epdf* marginal ( const RV &rv ) const {it_warning ( "Not implemented" ); return NULL;}
+	//! return expected value
+	virtual vec mean() const {it_error("not implemneted");return vec(0);};
+	//! return expected variance (not covariance!)
+	virtual vec variance() const {it_error("not implemneted");return vec(0);};
+	//!@}
+	
+	//! \name Connection to other classes
+	//! Description of the random quantity via attribute \c rv is optional. 
+	//! For operations such as sampling \c rv does not need to be set. However, for \c marginalization 
+	//! and \c conditioning \c rv has to be set. NB: 
+	//! @{
+	
+	//!Name its rv
+	void set_rv ( const RV &rv0 ) {rv = rv0; }//it_assert_debug(isnamed(),""); };
+	//! True if rv is assigned 
+	bool isnamed() const {bool b=( dim==rv._dsize() );return b;}
+	//! Return name (fails when isnamed is false)
+	const RV& _rv() const {it_assert_debug ( isnamed(),"" ); return rv;}
+	//!@}
+	
+	//! \name Access to attributes
+	//! @{
+	
+	//! Size of the random variable
+	int dimension() const {return dim;}
+	//!@}
+	
+};
 
 
